﻿B4J=true
Group=Pages
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'BANano compatible ONLY code. You can not use typical B4J libraries here.  Use their BANano version (if it exists)
'Making changes in a this module/class in B4J debug mode will NOT have any effect until recompiled!
Sub Class_Globals
	Private BANano As BANano 'ignore
	Private ws As BANanoWebSocket
	
	' from the MainLayout
	Private MainHamburgerMenu As SKLabel 'ignore
	Private MainSidebar As SKSidebar 'ignore
	Private MainPageHolder As SKContainer 'ignore
	
	' from the WelcomeModalLayout
	Private WelcomeModal As SKModal 'ignore
	Private WelcomeModalMessage As SKLabel 'ignore
	
	' from the WelcomePageLayout
	Private WelcomePageName As SKTextBox 'ignore
	Private WelcomePageButton As SKButton 'ignore
	
	' from the MenuLayout
	Private MenuList As SKMenu 'ignore
	
	' some media queries for our responsive menu
	Private Bigger992px As BANanoMediaQuery
	Private Smaller992px As BANanoMediaQuery
	
	Private Counter As Long
End Sub

'Initializes the object. You can NOT add extra parameters!
Public Sub Initialize
	' does the browser support websockets?
	If ws.IsSupported Then
		' here we connect to our SERVERTemplate websocket class using the 'classic' B4J Websocket events WebSocket_Connected and WebSocket_Disconnected
		' this must match with the first parameter of .AddWebSocket in Main!
		' Server.AddWebSocket("/ws/" & Server.BANano.StaticFolder & "/template" , "SERVERTemplate")
		ws.Initialize("ws://" & BANano.Location.GetHost & "/ws/" & BANano.StaticFolder & "/template")
	End If
End Sub

' Server says socket is ready
Sub WebSocket_Connected()
	Log("Connected ===> My B4J PageId: " & BANano.GetPageID)
	
End Sub

Sub WebSocket_Disconnected(event As BANanoEvent)
	Log("Websocket closed")
End Sub

public Sub BANano_Ready()
	Private body As BANanoElement
	body.Initialize("#body")
	
	' append and load our main layout
	body.Append($"<div id="mainHolder"></div>"$).Get("#mainHolder").LoadLayout("MainLayout")
	' append and load a modal sheet
	body.Append($"<div id="modalHolder"></div>"$).Get("#modalHolder").LoadLayout("WelcomeModalLayout")
	
	' loading our menu in our sidebar
	MainSidebar.Element.LoadLayout("MenuLayout")
	
	' making the menu layout responsive: always open when screen size is bigger than 992px
	Bigger992px.Initialize("(min-width: 992px)")
	Smaller992px.Initialize("(max-width: 991px)")
	
	' add our menu items
	MenuList.AddMenuItem("", "page1", "fas fa-user", "{NBSP}{NBSP}Welcome page")
	MenuList.Start
		
	' load our first page
	MainPageHolder.Element.LoadLayout("WelcomePageLayout")
End Sub

Sub Bigger992px_Matched()
	MainSidebar.AlwaysOpen = True
	' and hide the hamburger button
	MainHamburgerMenu.Element.SetStyle($"{"visibility": "hidden"}"$)
End Sub

Sub Smaller992px_Matched()
	MainSidebar.AlwaysOpen = False
	' and show the hamburger button
	MainHamburgerMenu.Element.SetStyle($"{"visibility": "unset"}"$)
End Sub

Sub WelcomePageButton_Click (event As BANanoEvent)
	If WelcomePageName.Text = "" Then
		Counter = Counter + 1
		' must end with _BAN and have only one parameter (a map)
		ws.B4JSend("SERVERForgotHisName_BAN", CreateMap("counter": Counter))
		SKTools.ShowToast("Please enter your name!", "info", 3000, True)
		Return
	End If
	WelcomeModalMessage.Text = "Welcome " & WelcomePageName.Text
	
	WelcomeModal.Open
End Sub

Sub MenuList_Click (returnName As String)
	SKTools.ShowToast("Clicked on " & returnName & "!", "info", 3000, True)
	' here we can load the layout of the menu item we clicked
	Select Case returnName
		Case "page1"
			MainPageHolder.Element.Empty
			MainPageHolder.Element.LoadLayout("WelcomePageLayout")
	End Select
	' and close the menu, if not always open
	If MainSidebar.AlwaysOpen = False Then
		MainSidebar.Close
	End If
End Sub

Sub MainHamburgerMenu_Click (event As BANanoEvent)
	MainSidebar.Open
End Sub

' the SERVER counterpart of this BROWSER page can ask what the current value of counter is
public Sub BROWSERAskForCounter() As Long
	Return Counter
End Sub

